#include <cstrike>
#include <sourcemod>
#include <sdktools>
#include <sdkhooks>


#pragma semicolon 1

// Define
#define PLUGIN_VERSION "1.1"

// Ints
int kills[MAXPLAYERS+1];

// Convars
ConVar sPluginEnabled;
ConVar sOverlaysColor;
ConVar sSoundEnabled;

public Plugin myinfo = 
{
	name = "[CSS/CSGO] SLAYER Kill Streak",
	author = "SLAYER",
	description = "Show Overlays on kill Streak",
	version = PLUGIN_VERSION,
	url = "https://forums.alliedmods.net/member.php?u=293943"
};

EngineVersion g_Game;
public void OnPluginStart()
{
	g_Game = GetEngineVersion();
	if(g_Game != Engine_CSGO && g_Game != Engine_CSS && g_Game != Engine_SourceSDK2006)
	{
		SetFailState("This plugin is for CSGO/CSS only.");
	}
	sPluginEnabled = CreateConVar("killstreak_enabled", "1", "Enabled/Disabled Kill Streak Plugin", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sOverlaysColor = CreateConVar("killstreak_overlays_color", "0", "Kill Streak Overlays Color (0 = Green, 1 = Red)", FCVAR_NOTIFY, true, 0.0, true, 1.0);
	sSoundEnabled = CreateConVar("killstreak_sounds_type", "1", "Enabled/Disabled Kill Streak Sounds (0 = Disabled, 1 = Enabled)", FCVAR_NOTIFY);
	HookEvent("round_start", Event_RoundStart, EventHookMode_PostNoCopy);
	HookEvent("player_death", Event_PlayerDeath);
	HookConVarChange(sPluginEnabled, OnConvarChanged);HookConVarChange(sOverlaysColor, OnConvarChanged);HookConVarChange(sSoundEnabled, OnConvarChanged);
	AutoExecConfig(true, "SLAYER_KillStreak");
}
public OnConvarChanged(ConVar convar, const char[] oldValue, const char[] newValue)
{
	if(convar == sPluginEnabled){if(convar.BoolValue){sPluginEnabled.BoolValue = true;PrintToChatAll("Kill Streak Plugin is now Enabled!");}else{sPluginEnabled.BoolValue = false;PrintToChatAll("Kill Streak Plugin is now Disabled!");}}
	if(convar == sOverlaysColor){if(convar.BoolValue){sOverlaysColor.BoolValue = true;}else{sOverlaysColor.BoolValue = false;}}
	if(convar == sSoundEnabled){if(convar.BoolValue){sSoundEnabled.BoolValue = true;}else{sSoundEnabled.BoolValue = false;}}
}
public void OnMapStart()
{
	DownloadableContent();
}
public Event_PlayerDisconnect(Handle event, const char[] name, bool dontBroadcast)
{
	int attacker = GetClientOfUserId(GetEventInt(event, "userid"));
	kills[attacker] = 0;
}
public void Event_RoundStart(Handle event, const char[] name, bool dontBroadcast)
{
	if(sPluginEnabled.BoolValue) // check plugin is enabled or disabled
	{
		for(new i = 1; i < MAXPLAYERS; i++)
		{
			kills[i] = 0;
		}
	}
}
public Event_PlayerDeath(Handle event, const char[] name, bool dontBroadcast)
{
	int victim = GetClientOfUserId(GetEventInt(event, "userid"));
	int attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
	if(attacker == 0){return;}
	if(GetClientTeam(attacker) != GetClientTeam(victim))
	{
		kills[attacker]++;
	}
	int iFlags = GetCommandFlags("r_screenoverlay");
	SetCommandFlags("r_screenoverlay", iFlags &~ FCVAR_CHEAT);
	if(kills[attacker] == 1)
	{
		if(sSoundEnabled.BoolValue)ClientCommand(attacker, "play slayer/overlays/firstblood.mp3");
		if(!sOverlaysColor.BoolValue)ClientCommand(attacker, "r_screenoverlay slayer/overlays/onekillgreen.vmt");
		if(sOverlaysColor.BoolValue)ClientCommand(attacker, "r_screenoverlay slayer/overlays/onekillred.vmt");
		CreateTimer(1.6, RemoveOverlay, attacker);
	}
	if(kills[attacker] == 2)
	{
		if(sSoundEnabled.BoolValue)ClientCommand(attacker, "play slayer/overlays/doublekill.mp3");
		if(!sOverlaysColor.BoolValue)ClientCommand(attacker, "r_screenoverlay slayer/overlays/twokillgreen.vmt");
		if(sOverlaysColor.BoolValue)ClientCommand(attacker, "r_screenoverlay slayer/overlays/twokillred.vmt");
		CreateTimer(1.4, RemoveOverlay, attacker);
	}
	if(kills[attacker] == 3)
	{
		if(sSoundEnabled.BoolValue)ClientCommand(attacker, "play slayer/overlays/triplekill.mp3");
		if(!sOverlaysColor.BoolValue)ClientCommand(attacker, "r_screenoverlay slayer/overlays/threekillgreen.vmt");
		if(sOverlaysColor.BoolValue)ClientCommand(attacker, "r_screenoverlay slayer/overlays/threekillred.vmt");
		CreateTimer(1.6, RemoveOverlay, attacker);
	}
	if(kills[attacker] == 4)
	{
		if(sSoundEnabled.BoolValue)ClientCommand(attacker, "play slayer/overlays/qudrakill.mp3");
		if(!sOverlaysColor.BoolValue)ClientCommand(attacker, "r_screenoverlay slayer/overlays/fourkillgreen.vmt");
		if(sOverlaysColor.BoolValue)ClientCommand(attacker, "r_screenoverlay slayer/overlays/fourkillred.vmt");
		CreateTimer(1.4, RemoveOverlay, attacker);
	}
	if(kills[attacker] == 5)
	{
		if(sSoundEnabled.BoolValue){
		for (new i = 1; i <= MaxClients; i++) // play Sound to all players on Special Round End
		{
		    if (IsClientInGame(i) && IsClientConnected(i))
		    {
		    	ClientCommand(i, "play slayer/overlays/pentakill.mp3");
		    }
		}}
		if(!sOverlaysColor.BoolValue)ClientCommand(attacker, "r_screenoverlay slayer/overlays/fivekillgreen.vmt");
		if(sOverlaysColor.BoolValue)ClientCommand(attacker, "r_screenoverlay slayer/overlays/fivekillred.vmt");
		CreateTimer(3.7, RemoveOverlay, attacker);
	}
	if(kills[attacker] == 6)
	{
		if(sSoundEnabled.BoolValue){
		for (new i = 1; i <= MaxClients; i++) // play Sound to all players on Special Round End
		{
		    if (IsClientInGame(i) && IsClientConnected(i))
		    {
		    	ClientCommand(i, "play slayer/overlays/hexakill.mp3");
		    }
		}}
		if(!sOverlaysColor.BoolValue)ClientCommand(attacker, "r_screenoverlay slayer/overlays/sixkillgreen.vmt");
		if(sOverlaysColor.BoolValue)ClientCommand(attacker, "r_screenoverlay slayer/overlays/sixkillred.vmt");
		CreateTimer(3.7, RemoveOverlay, attacker);
	}
}
public Action RemoveOverlay(Handle timer, any:client)
{
	int iFlags = GetCommandFlags("r_screenoverlay");
	SetCommandFlags("r_screenoverlay", iFlags &~ FCVAR_CHEAT);
	ClientCommand(client, "r_screenoverlay \"\"");
	SetCommandFlags("r_screenoverlay", iFlags);
}
void DownloadableContent()
{
	AddFileToDownloadsTable("materials/slayer/overlays/onekillgreen.vmt");
	AddFileToDownloadsTable("materials/slayer/overlays/twokillgreen.vmt");
	AddFileToDownloadsTable("materials/slayer/overlays/threekillgreen.vmt");
	AddFileToDownloadsTable("materials/slayer/overlays/fourkillgreen.vmt");
	AddFileToDownloadsTable("materials/slayer/overlays/fivekillgreen.vmt");
	AddFileToDownloadsTable("materials/slayer/overlays/sixkillgreen.vmt");
	AddFileToDownloadsTable("materials/slayer/overlays/onekillgreen.vtf");
	AddFileToDownloadsTable("materials/slayer/overlays/twokillgreen.vtf");
	AddFileToDownloadsTable("materials/slayer/overlays/threekillgreen.vtf");
	AddFileToDownloadsTable("materials/slayer/overlays/fourkillgreen.vtf");
	AddFileToDownloadsTable("materials/slayer/overlays/fivekillgreen.vtf");
	AddFileToDownloadsTable("materials/slayer/overlays/sixkillgreen.vtf");
	AddFileToDownloadsTable("materials/slayer/overlays/onekillred.vmt");
	AddFileToDownloadsTable("materials/slayer/overlays/twokillred.vmt");
	AddFileToDownloadsTable("materials/slayer/overlays/threekillred.vmt");
	AddFileToDownloadsTable("materials/slayer/overlays/fourkillred.vmt");
	AddFileToDownloadsTable("materials/slayer/overlays/fivekillred.vmt");
	AddFileToDownloadsTable("materials/slayer/overlays/sixkillred.vmt");
	AddFileToDownloadsTable("materials/slayer/overlays/onekillred.vtf");
	AddFileToDownloadsTable("materials/slayer/overlays/twokillred.vtf");
	AddFileToDownloadsTable("materials/slayer/overlays/threekillred.vtf");
	AddFileToDownloadsTable("materials/slayer/overlays/fourkillred.vtf");
	AddFileToDownloadsTable("materials/slayer/overlays/fivekillred.vtf");
	AddFileToDownloadsTable("materials/slayer/overlays/sixkillred.vtf");
	AddFileToDownloadsTable("sound/slayer/overlays/firstblood.mp3");
	AddFileToDownloadsTable("sound/slayer/overlays/doublekill.mp3");
	AddFileToDownloadsTable("sound/slayer/overlays/triplekill.mp3");
	AddFileToDownloadsTable("sound/slayer/overlays/qudrakill.mp3");
	AddFileToDownloadsTable("sound/slayer/overlays/pentakill.mp3");
	AddFileToDownloadsTable("sound/slayer/overlays/hexakill.mp3");
	PrecacheModel("materials/slayer/overlays/onekillgreen.vmt", true);
	PrecacheModel("materials/slayer/overlays/twokillgreen.vmt", true);
	PrecacheModel("materials/slayer/overlays/threekillgreen.vmt", true);
	PrecacheModel("materials/slayer/overlays/fourkillgreen.vmt", true);
	PrecacheModel("materials/slayer/overlays/fivekillgreen.vmt", true);
	PrecacheModel("materials/slayer/overlays/sixkillgreen.vmt", true);
	PrecacheModel("materials/slayer/overlays/onekillred.vmt", true);
	PrecacheModel("materials/slayer/overlays/twokillred.vmt", true);
	PrecacheModel("materials/slayer/overlays/threekillred.vmt", true);
	PrecacheModel("materials/slayer/overlays/fourkillred.vmt", true);
	PrecacheModel("materials/slayer/overlays/fivekillred.vmt", true);
	PrecacheModel("materials/slayer/overlays/sixkillred.vmt", true);
	PrecacheSound("slayer/overlays/firstblood.mp3", true);
	PrecacheSound("slayer/overlays/doublekill.mp3", true);
	PrecacheSound("slayer/overlays/triplekill.mp3", true);
	PrecacheSound("slayer/overlays/qudrakill.mp3", true);
	PrecacheSound("slayer/overlays/pentakill.mp3", true);
	PrecacheSound("slayer/overlays/hexakill.mp3", true);
}